/*
** wiregl_common.h
** http://graphics.stanford.edu/software/wiregl
**
** Copyright  2000 The Board of Trustees of The Leland Stanford Junior
** University. All rights reserved.
** Except for commercial resale, lease, license or other commercial
** transactions, permission is hereby given to use, copy, and/or modify
** this software, provided that the above copyright notice and this
** permission notice appear in all copies of this software.  No part of
** this software or any derivatives thereof may be used in graphics systems
** for resale or for use in a commercial product.
**
** This software is provided "as is" and without warranty of any kind, 
** express, implied or otherwise, including without limitation, any warranty 
** of merchantability or fitness for a particular purpose.
**
*/

#ifndef WIREGL_COMMON_H
#define WIREGL_COMMON_H

typedef struct {
	int window_x, window_y;
	unsigned int window_width, window_height;
	int feather_top_size;
	int feather_bottom_size;
	int feather_left_size;
	int feather_right_size;
	float feather_top[4];
	float feather_bottom[4];
	float feather_left[4];
	float feather_right[4];
	int feather_top_dice;
	int feather_bottom_dice;
	int feather_left_dice;
	int feather_right_dice;

	unsigned char please_share_memory;
	unsigned char please_use_gm;
} WireGLClientConnection;

#define WIREGL_PORT 7000
#define WIREGL_GM_PORT 4
#define PIPESERVER_BARRIER 69

#endif /* WIREGL_COMMON_H */
