##
## internal_header.py
## http://graphics.stanford.edu/software/wiregl
##
## Copyright  2000 The Board of Trustees of The Leland Stanford Junior
## University. All rights reserved.
## Except for commercial resale, lease, license or other commercial
## transactions, permission is hereby given to use, copy, and/or modify
## this software, provided that the above copyright notice and this
## permission notice appear in all copies of this software.  No part of
## this software or any derivatives thereof may be used in graphics systems
## for resale or for use in a commercial product.
##
## This software is provided "as is" and without warranty of any kind, 
## express, implied or otherwise, including without limitation, any warranty 
## of merchantability or fitness for a particular purpose.
##

import sys;
import cPickle;
import string;
import re;

import wiregl_common;

parsed_file = open( "gl_header.parsed", "rb" )
gl_mapping = cPickle.load( parsed_file )

print """
/*
** Generated by internal_header.py
** http://graphics.stanford.edu/software/wiregl
**
** Copyright  2000 The Board of Trustees of The Leland Stanford Junior
** University. All rights reserved.
** Except for commercial resale, lease, license or other commercial
** transactions, permission is hereby given to use, copy, and/or modify
** this software, provided that the above copyright notice and this
** permission notice appear in all copies of this software.  No part of
** this software or any derivatives thereof may be used in graphics systems
** for resale or for use in a commercial product.
**
** This software is provided "as is" and without warranty of any kind, 
** express, implied or otherwise, including without limitation, any warranty 
** of merchantability or fitness for a particular purpose.
**
*/

#ifndef WIREGL_PROTOCOL_H
#define WIREGL_PROTOCOL_H

#include "wiregl/include/wireGL.h"
#include "wiregl/glcontext/glcontext.h"

#ifdef __cplusplus
extern "C" {
#endif

"""

keys = gl_mapping.keys()
keys.sort();

print "typedef enum {"

enum_index = 0
for index in range(0,len(keys)):
	func_name = keys[index]
	if not wiregl_common.FindSpecial( "internal_header", func_name ):
		print "\t" + wiregl_common.OpcodeName( func_name ) + " = " + `enum_index` + ","
		enum_index = enum_index + 1

print "\t" + wiregl_common.OpcodeName( "SwapBuffers" ) + ","
print "\t" + wiregl_common.OpcodeName( "CreateContext" ) + ","
print "\t" + wiregl_common.OpcodeName( "GMDeath" ) + ","
print "\t" + wiregl_common.OpcodeName( "UpdateClientPointer" )
print "} WireGLOpcode;\n"

print """
void *wireGLAllocPacket( unsigned int size );
void wireGLFreePacket( void *packet );
void wireGLSendPacket( unsigned char opcode, void *packet );
void wireGLSendRawData( void *data, int len );
void wireGLDecode( unsigned char opcode, void *packet );
void wireGLFlushBuffer( GLcontext * );
void wireGLFlushAll( GLcontext *, WireGLOpcode );
void wireGLGMDeath( );

extern int packet_length_table[];

#define GET_BUFFERED_POINTER( len ) \\
  data_ptr = pipe_server_data_current; \\
  if (data_ptr + (len) > pipe_server_data_end )\\
  { \\
    wireGLFlushBuffer( pipe_server_state ); \\
	data_ptr = pipe_server_data_current; \\
  } \\
  pipe_server_data_current += (len)

#define WRITE_DATA( offset, type, data ) \\
  *( (type *) (data_ptr + (offset))) = (data)

#define WRITE_OPCODE( opcode ) \\
  *(pipe_server_opcode_current++) = opcode
"""
for func_name in keys:
	print "extern void *" + wiregl_common.DoImmediateMapping( func_name ) + ";"

print """

#ifdef __cplusplus
}
#endif

#endif /* WIREGL_PROTOCOL_H */
"""
