##
## windows_exports.py
## http://graphics.stanford.edu/software/wiregl
##
## Copyright  2000 The Board of Trustees of The Leland Stanford Junior
## University. All rights reserved.
## Except for commercial resale, lease, license or other commercial
## transactions, permission is hereby given to use, copy, and/or modify
## this software, provided that the above copyright notice and this
## permission notice appear in all copies of this software.  No part of
## this software or any derivatives thereof may be used in graphics systems
## for resale or for use in a commercial product.
##
## This software is provided "as is" and without warranty of any kind, 
## express, implied or otherwise, including without limitation, any warranty 
## of merchantability or fitness for a particular purpose.
##

import sys;
import cPickle;
import types;
import string;
import re;

import wiregl_common;

parsed_file = open( "gl_header.parsed", "rb" )
gl_mapping = cPickle.load( parsed_file )

keys = gl_mapping.keys()
keys.sort();

print """
/*
** Generated by windows_exports.py
** http://graphics.stanford.edu/software/wiregl
**
** Copyright  2000 The Board of Trustees of The Leland Stanford Junior
** University. All rights reserved.
** Except for commercial resale, lease, license or other commercial
** transactions, permission is hereby given to use, copy, and/or modify
** this software, provided that the above copyright notice and this
** permission notice appear in all copies of this software.  No part of
** this software or any derivatives thereof may be used in graphics systems
** for resale or for use in a commercial product.
**
** This software is provided "as is" and without warranty of any kind, 
** express, implied or otherwise, including without limitation, any warranty 
** of merchantability or fitness for a particular purpose.
**
*/

#include "wiregl/include/wireGL.h"
#include "wiregl/include/wiregl_protocol.h"
#include <stdlib.h>
#include <stdio.h>

#ifdef WINDOWS
#define NAKED __declspec(naked)
#else
#define NAKED
#endif

"""

for func_name in keys:
	( return_type, arg_names, arg_types ) = gl_mapping[func_name]

	print "NAKED " + return_type + ' gl' + func_name,
	wiregl_common.PrintArguments( arg_names, arg_types )
	print '{'
	print '\t__asm jmp [' + wiregl_common.DoImmediateMapping( func_name ) + ']'

	#if return_type != "void":
		#print "\treturn (" + return_type + ") 0; /* THIS WILL NOT BE REACHED */"

	print '}\n'

