/*
** matrices.c
** http://graphics.stanford.edu/software/wiregl
**
** Copyright  2000 The Board of Trustees of The Leland Stanford Junior
** University. All rights reserved.
** Except for commercial resale, lease, license or other commercial
** transactions, permission is hereby given to use, copy, and/or modify
** this software, provided that the above copyright notice and this
** permission notice appear in all copies of this software.  No part of
** this software or any derivatives thereof may be used in graphics systems
** for resale or for use in a commercial product.
**
** This software is provided "as is" and without warranty of any kind, 
** express, implied or otherwise, including without limitation, any warranty 
** of merchantability or fitness for a particular purpose.
**
*/

#ifdef WINDOWS
#include <windows.h>
#endif
#include <GL/gl.h>

#include "wiregl/include/wireGL.h"
#include "wiregl/include/wiregl_protocol.h"
#include "wiregl/include/wiregl_pipe.h"
#include "wiregl/include/wiregl_util.h"

void __decodeMultMatrixd( void  )
{
	glMultMatrixd(
		DATA_POINTER( 0, GLdouble )	/* m */
		 );
	INCR_DATA_PTR( 16*sizeof( GLdouble ) );
}

void __decodeMultMatrixf( void  )
{
	glMultMatrixf(
		DATA_POINTER( 0, GLfloat )	/* m */
		 );
	INCR_DATA_PTR( 16*sizeof( GLfloat ) );
}

void __decodeLoadMatrixd( void  )
{
	glLoadMatrixd(
		DATA_POINTER( 0, GLdouble )	/* m */
		 );
	INCR_DATA_PTR( 16*sizeof( GLdouble ) );
}

void __decodeLoadMatrixf( void  )
{
	glLoadMatrixf(
		DATA_POINTER( 0, GLfloat )	/* m */
		 );
	INCR_DATA_PTR( 16*sizeof( GLfloat ) );
}

void __decodeMatrixMode( void )
{
	GLenum mode = READ_DATA( 0, GLenum );
	__gltrack_MatrixMode( mode  );
	INCR_DATA_PTR( 4 );
}