/*
** swap.c
** http://graphics.stanford.edu/software/wiregl
**
** Copyright  2000 The Board of Trustees of The Leland Stanford Junior
** University. All rights reserved.
** Except for commercial resale, lease, license or other commercial
** transactions, permission is hereby given to use, copy, and/or modify
** this software, provided that the above copyright notice and this
** permission notice appear in all copies of this software.  No part of
** this software or any derivatives thereof may be used in graphics systems
** for resale or for use in a commercial product.
**
** This software is provided "as is" and without warranty of any kind, 
** express, implied or otherwise, including without limitation, any warranty 
** of merchantability or fitness for a particular purpose.
**
*/

#include "wiregl/include/wiregl_protocol.h"
#include "wiregl/include/wiregl_pipe.h"

#include "feather.h"

#if defined (IRIX) || defined( IRIX64 ) || defined( Linux)
#include <X11/Xlib.h>

#ifdef __cplusplus
#define C_EXTERN "C"
#else
#define C_EXTERN
#endif

typedef XID GLXDrawable;
extern C_EXTERN void glXSwapBuffers (Display *dpy, GLXDrawable drawable);
#endif

void __decodeSwapBuffers( void )
{
	static int featherinit = 0;

	if (!featherinit) {
		__configureFeathering ( wiregl_pipe.window_width, wiregl_pipe.window_height,
			wiregl_pipe.feather_left_size, wiregl_pipe.feather_right_size,
			wiregl_pipe.feather_top_size, wiregl_pipe.feather_bottom_size,
			wiregl_pipe.feather_left, wiregl_pipe.feather_right,
			wiregl_pipe.feather_top, wiregl_pipe.feather_bottom);
		featherinit = 1;
	}

	__drawFeatheringStrips();

#ifdef WINDOWS
	SwapBuffers( wiregl_pipe.device_context );
#else
	glXSwapBuffers( wiregl_pipe.dpy, wiregl_pipe.win );
#endif
}
