##
## unpacker.py
## http://graphics.stanford.edu/software/wiregl
##
## Copyright  2000 The Board of Trustees of The Leland Stanford Junior
## University. All rights reserved.
## Except for commercial resale, lease, license or other commercial
## transactions, permission is hereby given to use, copy, and/or modify
## this software, provided that the above copyright notice and this
## permission notice appear in all copies of this software.  No part of
## this software or any derivatives thereof may be used in graphics systems
## for resale or for use in a commercial product.
##
## This software is provided "as is" and without warranty of any kind, 
## express, implied or otherwise, including without limitation, any warranty 
## of merchantability or fitness for a particular purpose.
##

import sys;
import cPickle;
import types;
import string;
import re;

import wiregl_common;

parsed_file = open( "../opengl_stub/gl_header.parsed", "rb" )
gl_mapping = cPickle.load( parsed_file )

print """
/*
** http://graphics.stanford.edu/software/wiregl
**
** Copyright  2000 The Board of Trustees of The Leland Stanford Junior
** University. All rights reserved.
** Except for commercial resale, lease, license or other commercial
** transactions, permission is hereby given to use, copy, and/or modify
** this software, provided that the above copyright notice and this
** permission notice appear in all copies of this software.  No part of
** this software or any derivatives thereof may be used in graphics systems
** for resale or for use in a commercial product.
**
** This software is provided "as is" and without warranty of any kind, 
** express, implied or otherwise, including without limitation, any warranty 
** of merchantability or fitness for a particular purpose.
*/

#ifdef WINDOWS
#include <windows.h>
#endif
#include <GL/gl.h>

#include "wiregl/include/wireGL.h"
#include "wiregl/include/wiregl_protocol.h"
#include "wiregl/include/wiregl_pipe.h"
#include "wiregl/include/wiregl_util.h"


#include <string.h>

char *glNames[] = {
"""

keys = gl_mapping.keys()
keys.sort();

for func_name in keys:
	if (wiregl_common.FindSpecial( "../opengl_stub/internal_header", func_name ) ): continue
	print '"' + func_name + '",'
print '"SwapBuffers",'
print '"CreateContext",'
print '"GMDeath",'
print '"UpdateClientPointer"'
print "};"

print "void " + wiregl_common.DecoderName( "NOP" ) + "( void ) {} "

def MakeVector( func_name ):
	return func_name + "v"

for func_name in keys:
	if wiregl_common.FindSpecial( "../opengl_stub/internal_header", func_name ): continue
	if wiregl_common.FindSpecial( "unpacker", func_name ): continue

	( return_type, arg_names, arg_types ) = gl_mapping[func_name]
	print "void " + wiregl_common.DecoderName( func_name ) + "( void )"
	print "{"

	packet_length = wiregl_common.PacketLength( arg_types )
	if packet_length == -1:
		print '\twireGLSimpleError( "' + func_name + "'s decoder needs to be special cased!\");"
	else:
		output = "\t"
		counter = 0;
		if not wiregl_common.FindSpecial( "unpacker_vector", func_name ):
			for i in range( 0, len(arg_names) ):
				if arg_names[i] != '':
					print "\t" + arg_types[i] + " " + arg_names[i] + " = READ_DATA( " + `counter` + ", " + arg_types[i] + " );"
					counter = counter + wiregl_common.lengths[arg_types[i]]

		if return_type != "void":
			output = output + "(void) "
		if not wiregl_common.FindSpecial( "unpacker_vector", func_name ):
			output = output + "gl" + func_name + "( "
			for i in range( 0, len(arg_names) ):
				if arg_names[i] != '':
					output = output + arg_names[i] 
					if i != len(arg_names) - 1:
						output = output + ", "
					else:
						output = output + " "
		else:
			output = output + "gl" + MakeVector( func_name ) + "( ( " + arg_types[0] + "* ) unpacker_data_ptr"
		output = output + " );"
		print output
		if wiregl_common.FindSpecial( "unpacker_state", func_name ):
			output =  "\t__glstate_" + func_name[2:] + "( "
			for index in range( 0, len( arg_names ) ):
				arg = arg_names[index]
				if arg != '':
					output = output + arg
					if index != len( arg_names ) - 1:
						output = output + ", "
			output = output + " );"
			print output
		print "\tINCR_DATA_PTR( " + `packet_length` + " );"
	print "}"

for special in wiregl_common.AllSpecials( "unpacker" ):
	print "extern void " + wiregl_common.DecoderName(special) + "( void );"

print """
wiregl_decoder wiregl_decode_functions[] = {
"""

for func_name in keys:
	if wiregl_common.FindSpecial( "../opengl_stub/internal_header", func_name ): continue
	print "\t" + wiregl_common.DecoderName( func_name ) + ","

print "\t" + wiregl_common.DecoderName( "SwapBuffers" ) + ","
print "\t" + wiregl_common.DecoderName( "NOP" ) + "," #CreateContext
print "\t" + wiregl_common.DecoderName( "GMDeath" ) + ","
print "\t" + wiregl_common.DecoderName( "UpdateClientPointer" )
print "};"
